#line 0 "source/imagesUpdate.c"
/*
 * imagesUpdate.c
 *
 * Copyright (C) an0nym0us
 *
 * This software is distributed under the terms of the GNU General Public
 * License ("GPL") version 3, as published by the Free Software Foundation.
 *
 */

/*
 * includes
 */

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <inttypes.h>

#include "common.h"
#include "debug.h"
#include "images.h"


/*
 * functions
 */

/* draw center buffer image into main buffer */
/*
inline void
imagesUpdateImages ( imagesData *i_data, videoutilData *vu_data )
{
  //TIMING_START() ;
  imagesDrawImages ( i_data, vu_data ) ;
  //TIMING_END() ;
  //TIMING_PRINT() ;
}
*/

/* draw center buffer image into main buffer */
inline void
imagesUpdateMainBufferImages ( imagesData *i_data, videoutilData *vu_data )
{
  //TIMING_START() ;
  imagesDrawImageMainBuffer ( i_data, vu_data ) ;
  //TIMING_END() ;
  //TIMING_PRINT() ;
}

/* draw center buffer image into main buffer */
inline void
imagesUpdateHelpBufferImages ( imagesData *i_data, videoutilData *vu_data )
{
  //TIMING_START() ;
  imagesDrawImageHelpBuffer ( i_data, vu_data ) ;
  //TIMING_END() ;
  //TIMING_PRINT() ;
}

/* draw center buffer image into main buffer */
inline void
imagesUpdateAboutBufferImages ( imagesData *i_data, videoutilData *vu_data )
{
  //TIMING_START() ;
  imagesDrawImageAboutBuffer ( i_data, vu_data ) ;
  //TIMING_END() ;
  //TIMING_PRINT() ;
}

/* draw center buffer image into main buffer */
inline void
imagesUpdateDumpBufferImages ( imagesData *i_data, videoutilData *vu_data )
{
  //TIMING_START() ;
  imagesDrawImageDumpBuffer ( i_data, vu_data ) ;
  //TIMING_END() ;
  //TIMING_PRINT() ;
}

/* update dipswitch */
inline void
imagesUpdateDipswitch ( imagesData *i_data, videoutilData *vu_data )
{
  //TIMING_START() ;
  imagesDrawDipswitch ( i_data, vu_data ) ;
  //TIMING_END() ;
  //TIMING_PRINT() ;
}

/* update 7 segment LED display */
/*
inline void
imagesUpdateSevenSegment ( imagesData *i_data, videoutilData *vu_data )
{
  //TIMING_START() ;
  imagesDrawSevenSegment ( i_data, vu_data ) ;
  //TIMING_END() ;
  //TIMING_PRINT() ;
}
*/

/* update buttons */
/*
inline void
imagesUpdateButtons ( imagesData *i_data, videoutilData *vu_data )
{
  //TIMING_START() ;
  if ( i_data->buttons > 0 )
  {
    imagesDrawButtons ( i_data, vu_data ) ;
  }
  //TIMING_END() ;
  //TIMING_PRINT() ;
}
*/

/* update memory LEDs */
inline void
imagesUpdateMemoryLeds ( imagesData *i_data, videoutilData *vu_data )
{
  //TIMING_START() ;
  imagesDrawMemoryLeds ( i_data, vu_data ) ;
  //TIMING_END() ; 
  //TIMING_PRINT() ;
}

/* update IO LEDs */
inline void
imagesUpdateIoLeds ( imagesData *i_data, videoutilData *vu_data )
{
  //TIMING_START() ;
  imagesDrawIoLeds ( i_data, vu_data ) ;
  //TIMING_END() ;
  //TIMING_PRINT() ;
}

/* update progress LEDs */
inline void
imagesUpdateProgressLeds ( imagesData *i_data, videoutilData *vu_data )
{
  //TIMING_START() ;
  imagesDrawProgressLeds ( i_data, vu_data ) ;
  //TIMING_END() ;
  //TIMING_PRINT() ;
}

